$nocompile
'###############################################################################
'##                                                                           ##
'##                              M E N U D A T A                              ##
'##                       ===========================                         ##
'##                                                                           ##
'##  Description: menu data for EnOcean UniModule                             ##
'##                                                                           ##
'##                                                                           ##
'##  Version:     1.0                                       Date: March 2013  ##
'##                                                                           ##
'##  Author:      Hartmut Wendt                                               ##
'##  URL:         www.hwhardsoft.de                                           ##
'##                                                                           ##
'##  Copyright:   GNU Public License V3                                       ##
'##                                                                           ##
'##  note:                                                                    ##
'##  This program is free software: you can redistribute it and/or modify     ##
'##  it under the terms of the GNU General Public License as published by     ##
'##  the Free Software Foundation, either version 3 of the License, or        ##
'##  (at your option) any later version.                                      ##
'##  This program is distributed in the hope that it will be useful,          ##
'##  but WITHOUT ANY WARRANTY; without even the implied warranty of           ##
'##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            ##
'##  GNU General Public License for more details.                             ##
'##  You should have received a copy of the GNU General Public License        ##
'##  along with this program.  If not, see <http://www.gnu.org/licenses/>.    ##
'##                                                                           ##
'###############################################################################
Const Lcd_width = 16
Const Lcd_bar_style = 1
Const Lcd_bit_display_off = "Off"
Const Lcd_bit_display_on = "On"

Const Menu_entries_count = 59
Const Menu_default_entry = 1

Const Menu_values_use = True
Const Menu_values_edit_use = True
Const Menu_values_count = 24
Const Menu_value_bit_count = 12
Const Menu_value_byte_count = 8
Const Menu_value_word_count = 0
Const Menu_value_integer_count = 4
Const Menu_value_dword_count = 0
Const Menu_value_long_count = 0
Const Menu_value_single_count = 0
Const Menu_value_double_count = 0
Const Menu_value_string_count = 0

Goto Menu_data_jumpover

Menu_entries:
   ' Type, Text ID, Before, Next, Child
   'Main menu
   Data Menu_link , 0 , 4 , 2 , 5                           ' 1, Sensors
   Data Menu_link , 1 , 1 , 3 , 22                          ' 2, Thermostat
   Data Menu_link , 2 , 2 , 4 , 55                          ' 3, Options
   Data Menu_exit , 3 , 3 , 1 , 0                           ' 4, {127} Exit
   'Submenu Sensors
   Data Menu_link , 4 , 9 , 6 , 10                          ' 5, Channel1
   Data Menu_link , 5 , 5 , 7 , 13                          ' 6, Channel2
   Data Menu_link , 6 , 6 , 8 , 16                          ' 7, Channel3
   Data Menu_link , 7 , 7 , 9 , 19                          ' 8, Channel4
   Data Menu_link , 30 , 8 , 5 , 1                          ' 9, {127} Back

   'Submenu Sensors Channel 1
   Data Menu_value , 9 , 12 , 11 , 1                        ' 10, Sensor Type
   Data Menu_function , 10 , 10 , 12 , 11                   ' 11, LRN protocol
   Data Menu_link , 30 , 11 , 10 , 5                        ' 12, {127} Back

   'Submenu Sensors Channel 2
   Data Menu_value , 9 , 15 , 14 , 2                        ' 13, Sensor Type
   Data Menu_function , 10 , 13 , 15 , 12                   ' 14, LRN protocol
   Data Menu_link , 30 , 14 , 13 , 6                        ' 15, {127} Back

   'Submenu Sensors Channel 3
   Data Menu_value , 9 , 18 , 17 , 3                        ' 16, Sensor Type
   Data Menu_function , 10 , 16 , 18 , 13                   ' 17, LRN protocol
   Data Menu_link , 30 , 17 , 16 , 7                        ' 18, {127} Back

   'Submenu Sensors Channel 4
   Data Menu_value , 9 , 21 , 20 , 4                        ' 19, Sensor Type
   Data Menu_function , 10 , 19 , 21 , 14                   ' 20, LRN protocol
   Data Menu_link , 30 , 20 , 19 , 4                        ' 21, {127} Back

   'Submenu Thermostat
   Data Menu_link , 12 , 26 , 23 , 27                       ' 22, Threshold1
   Data Menu_link , 13 , 22 , 24 , 34                       ' 23, Threshold2
   Data Menu_link , 14 , 23 , 25 , 41                       ' 24, Threshold3
   Data Menu_link , 15 , 24 , 26 , 48                       ' 25, Threshold4
   Data Menu_link , 30 , 25 , 22 , 2                        ' 26, {127} Back

   'Submenu Thermostat Threshold 1
   Data Menu_value , 17 , 33 , 28 , 5                       ' 27, Temperature
   Data Menu_value , 18 , 27 , 29 , 6                       ' 28, Channel
   Data Menu_value , 19 , 28 , 30 , 7                       ' 29, TMT underrun
   Data Menu_value , 20 , 29 , 31 , 8                       ' 30, TMT overrun
   Data Menu_value , 21 , 30 , 32 , 9                       ' 31, Sensor Type
   Data Menu_function , 22 , 31 , 33 , 21                   ' 32, LRN protocol
   Data Menu_link , 30 , 32 , 27 , 22                       ' 33, {127} Back

   'Submenu Thermostat Threshold 2
   Data Menu_value , 17 , 40 , 35 , 10                      ' 34, Temperature
   Data Menu_value , 18 , 34 , 36 , 11                      ' 35, Channel
   Data Menu_value , 19 , 35 , 37 , 12                      ' 36, TMT underrun
   Data Menu_value , 20 , 36 , 38 , 13                      ' 37, TMT overrun
   Data Menu_value , 21 , 37 , 39 , 14                      ' 38, Sensor Type
   Data Menu_function , 22 , 38 , 40 , 22                   ' 39, LRN protocol
   Data Menu_link , 30 , 39 , 34 , 23                       ' 40, {127} Back

   'Submenu Thermostat Threshold 3
   Data Menu_value , 17 , 47 , 42 , 15                      ' 41, Temperature
   Data Menu_value , 18 , 41 , 43 , 16                      ' 42, Channel
   Data Menu_value , 19 , 42 , 44 , 17                      ' 43, TMT underrun
   Data Menu_value , 20 , 43 , 45 , 18                      ' 44, TMT overrun
   Data Menu_value , 21 , 44 , 46 , 19                      ' 45, Sensor Type
   Data Menu_function , 22 , 45 , 47 , 23                   ' 46, LRN protocol
   Data Menu_link , 30 , 46 , 41 , 24                       ' 47, {127} Back

   'Submenu Thermostat Threshold 4
   Data Menu_value , 17 , 54 , 49 , 20                      ' 48, Temperature
   Data Menu_value , 18 , 48 , 50 , 21                      ' 49, Channel
   Data Menu_value , 19 , 49 , 51 , 22                      ' 50, TMT underrun
   Data Menu_value , 20 , 50 , 52 , 23                      ' 51, TMT overrun
   Data Menu_value , 21 , 51 , 53 , 24                      ' 52, Sensor Type
   Data Menu_function , 22 , 52 , 54 , 24                   ' 53, LRN protocol
   Data Menu_link , 30 , 53 , 48 , 25                       ' 54, {127} Back

   'Submenu Options
   Data Menu_function , 24 , 59 , 56 , 31                   ' 55, Factory set.
   Data Menu_function , 25 , 55 , 57 , 32                   ' 56, Version
   Data Menu_function , 26 , 56 , 58 , 33                   ' 57, Ver. TCM320
   Data Menu_function , 27 , 57 , 59 , 34                   ' 58, BaseID
   Data Menu_link , 30 , 58 , 55 , 3                        ' 59, {127} Back


Menu_string_constants:

   'Main menu
   Data "Sensors"                                           ' 0
   Data "Thermostat"                                        ' 1
   Data "Options"                                           ' 2
   Data "{127} Exit"                                        ' 3
   'Submenu Sensors
   Data "Channel 1"                                         ' 4
   Data "Channel 2"                                         ' 5
   Data "Channel 3"                                         ' 6
   Data "Channel 4"                                         ' 7
   Data "dmy"                                               ' 8
   'Submenu Sensors Channel x
   Data "Sensor Type"                                       ' 9
   Data "LRN protocol"                                      ' 10
   Data "dmy"                                               ' 11
   'Submenu Thermostat
   Data "Threshold 1"                                       ' 12
   Data "Threshold 2"                                       ' 13
   Data "Threshold 3"                                       ' 14
   Data "Threshold 4"                                       ' 15
   Data "dmy"                                               ' 16
   'Submenu Thermostat Threshold x
   Data "Temperature"                                       ' 17
   Data "Channel"                                           ' 18
   Data "TMT underrun"                                      ' 19
   Data "TMT overrun"                                       ' 20
   Data "INV protocol"                                      ' 21
   Data "LRN protocol"                                      ' 22
   Data "dmy"                                               ' 23
   'Submenu Options
   Data "Factory set."                                      ' 24
   Data "Version"                                           ' 25
   Data "Ver TCM320"                                        ' 26
   Data "BaseID"                                            ' 27
   Data "dmy"                                               ' 28
   Data "dmy"                                               ' 29
   Data "{127} Back"                                        ' 30


Menu_values:
   ' Type, Value Child, Step/ReadOnly (if 0), Min, Max, [Init value]
   Data Menu_value_byte , 1 , 1 , 0 , 2 , 8%                ' 1, Sensor type 1
   Data Menu_value_byte , 1 , 1 , 0 , 2 , 9%                ' 2, Sensor type 2
   Data Menu_value_byte , 1 , 1 , 0 , 2 , 10%               ' 3, Sensor type 3
   Data Menu_value_byte , 1 , 1 , 0 , 2 , 11%               ' 4, Sensor type 4
   'Thermostat 1
   Data Menu_value_integer , 1 , 1% , -50% , 120% , 16%     ' 5, Temperature
   Data Menu_value_byte , 1 , 1 , 1 , 4 , 18%               ' 6, Channel
   Data Menu_value_bit , 1 , 1 , 19%                        ' 7, TMT underrun
   Data Menu_value_bit , 1 , 1 , 20%                        ' 8, TMT overrun
   Data Menu_value_bit , 1 , 1 , 21%                        ' 9, Invert
   'Thermostat 2
   Data Menu_value_integer , 1 , 1% , -50% , 120% , 32%     ' 10, Temperature
   Data Menu_value_byte , 1 , 1 , 1 , 4 , 34%               ' 11, Channel
   Data Menu_value_bit , 1 , 1 , 35%                        ' 12, TMT underrun
   Data Menu_value_bit , 1 , 1 , 36%                        ' 13, TMT overrun
   Data Menu_value_bit , 1 , 1 , 37%                        ' 14, Invert
   'Thermostat 3
   Data Menu_value_integer , 1 , 1% , -50% , 120% , 48%     ' 15, Temperature
   Data Menu_value_byte , 1 , 1 , 1 , 4 , 50%               ' 16, Channel
   Data Menu_value_bit , 1 , 1 , 51%                        ' 17, TMT underrun
   Data Menu_value_bit , 1 , 1 , 52%                        ' 18, TMT overrun
   Data Menu_value_bit , 1 , 1 , 53%                        ' 19, Invert
   'Thermostat 4
   Data Menu_value_integer , 1 , 1% , -50% , 120% , 64%     ' 20, Temperature
   Data Menu_value_byte , 1 , 1 , 1 , 4 , 66%               ' 21, Channel
   Data Menu_value_bit , 1 , 1 , 67%                        ' 22, TMT underrun
   Data Menu_value_bit , 1 , 1 , 68%                        ' 23, TMT overrun
   Data Menu_value_bit , 1 , 1 , 69%                        ' 24, Invert


Menu_string_characters:
   ' Table of characters used in string editing
   Data 254                                                 ' start of table, needed

   Data "ABCDEFGHIJKLMNOPQRSTUVWXYZ 0123456789"

   ' special characters with function, these are needed
   Data Menu_character_backspace                            ' backspace
   Data Menu_character_finish                               ' finish string editing
   Data 254                                                 ' end of table

Menu_data_jumpover: